-- $Id: baffle_driver_01.lua,v 1.1 2007/07/30 23:44:24 dj Exp $

$debug

local errpfx = 'baffle_driver_01: '

SAOTRACE_DB = getenv('SAOTRACE_DB')

if ( nil == SAOTRACE_DB ) then
  error (  errpfx .. 'environmental variable SAOTRACE_DB is not set' )
end

if ( nil == dofile( SAOTRACE_DB .. '/apertures/BaffleSet_03.lua' ) ) then
   error( errpfx .. "error compiling " .. SAOTRACE_DB .. '/apertures/BaffleSet_03.lua' )
end


override()


-- make sure that the important variables were set as globals in override()
foreach ( { 'assembly_name', 'config_db', 'shell' },
	 function ( i, v )
	    if ( nil == getglobal( v ) ) then
	       error( %errpfx .. "variable '" .. v .. "' was not set" )
	    end
	 end )


-- optional arguments
local args = { }

args.coord_type    = coord_type
args.insert_struts = insert_struts
args.tol_scale     = tol_scale


-- construct baffles


local baffles = BaffleSet:new( assembly_name, config_db, shell, args )


-- construct the assemblies for this baffle set
--
baffles:construct_baffles( debug_plate )

