-- $Id: entrance_ap_02.lua,v 1.3 2007/07/27 17:02:49 dj Exp $
--
-- Simple annulus entrance aperture, for use by raygen.
-- 
-- reads from an rdb datbase which must have the columns 
-- shell, x, y, z, ri, ro

SAOTRACE_LUALIB = getenv('SAOTRACE_LUALIB')

if ( nil == SAOTRACE_LUALIB ) then
  error ( 'entrance_ap_02.lua: unable to read environtmental variable SAOTRACE_LUALIB' )
end

dofile(  SAOTRACE_LUALIB .. '/RDB.lua' )

function entrance_aperture( ) 

  local rdb, i, match
  local errmsg

  -- this should define ea_db and shell

  override( );

  if ( nil == ea_db ) then
    error( 'entrance_ap_02.lua: ea_db not set' )
  end

  if ( nil == shell ) then
    error( 'entrance_ap_02.lua: shell not set' )
  end

  rdb, errmsg = RDB:new( ea_db )

  if ( nil == rdb ) then
     error ("entrance_ap_02.lua: error opening " .. ea_db .. ": " .. errmsg )
  end

  -- find the entry which corresponds to this shell

  match = nil

  local rec = rdb:read()
  while ( not match and rec ) do
     if ( tonumber(rec.shell) == shell ) then
	match = 1
     else
	rec = rdb:read()
     end 
  end

  rdb:close()

  if not match then
    error( "entrance_ap_02.lua: couldn't find shell=" .. shell .. " in " .. ea_db )
  end

  ea_define( "Entrance Aperture", 'annulus', 
	    rec.x, rec.y, rec.z, rec.ri, rec.ro )

end
